% SWEEPMICH (Michelson length) in DRFPMI and generate plots.
%
% [xPos, sigDC, fDC] = sweepMICH(Nsweep)
% see sweepDC for information about the parameters
%
% This displays some DC signals, and some demod signals, during
% a MICH sweep.  

function [xPos, sigDC, fDC] = sweepMICH(Nsweep)

  % Check number of input arguments
  if nargin < 1
    Nsweep = 100;
  elseif nargin > 1
    error('Too Many Arguments!')
  end

  % prepare some variables
  sweepSetup

  % adding this to sweepSetup causes matlab to crash, so do it here
  nDC = [nREFL(1) nAS(1) nPOX(1) nPOY(1) nTRX(1) nTRY(1)];

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % MICH sweep
  pos = zeros(opt.Noptic, 1);
  pos(nPR) = -65e-9;
  pos(nBS) = 100e-9;
  pos(nSR) = 65e-9;
  
  [xPos, sigDC, fDC] = sweepDC(opt, -pos, pos, Nsweep);

  % compute phase errors for double-demod signals
  Nmid = find(xPos(nBS, :) >= -1e-16, 1);
  phaseM = 180 * atan2(sigDC(nAS(5), Nmid), sigDC(nAS(4), Nmid)) / pi;
  phaseP = 180 * atan2(sigDC(nAS(7), Nmid), sigDC(nAS(6), Nmid)) / pi;
  checkPhases = (phaseM > 1) | (phaseP > 1);
  str = sprintf('double demod phase errors: %4.3f deg for %s, %4.3f deg for %s', ...
                phaseM, prbNames{nAS(4)}, phaseP, prbNames{nAS(6)});
  disp(str)
  phaseM = opt.probe(nAS(4)).phase - phaseM;
  phaseP = opt.probe(nAS(6)).phase - phaseP;
  str = sprintf('            good phases: %4.3f deg for %s, %4.3f deg for %s', ...
                phaseM, prbNames{nAS(4)}, phaseP, prbNames{nAS(6)});
  disp(str)
  disp('   ')
  
  if (~checkPhases)
    disp('Demod Phases are good enough')
  else
    disp('Fix demod phases in opt file')
  end
  disp('    ')
  
  % make some plots
  fDCp = permute(fDC, [2, 3, 1]);  
  n = getFieldAt(opt, nPR, 'fr');		% SR front input field

  sDD = sigDC(nAS(4:5), :) + sigDC(nAS(6:7), :);
  REFL166 = sigDC(nREFL(8:9),:)/30;
  
  subplot('position',[0.05 0.475 0.9 0.45])
  semilogy(xPos(nPR, :), abs(fDCp(nSBa, :, n)), ...
           xPos(nPR, :), abs(fDCp(nSBb, :, n)),'--')
  title('MICH sweep: RF powers (top) & Demods (bottom)',...
        'FontWeight','bold',...
        'FontSize',18)
  legend(num2str([vFrf(nSBa); vFrf(nSBb)] / 1e6))
  grid on
  axis([pos(nPR) -pos(nPR) 1e-3 1])
  set(gca,'XTickLabel',[])
  
  subplot('position',[0.05 0.06 0.9 0.4])
  plot(xPos(nPR, :)*1e9, [sigDC(nAS(4:7), :); sDD],...
       xPos(nPR, :)*1e9, REFL166(1,:),'--')
  legend(prbNames{nAS(4:7)}, 'AS IM + IP', 'AS QM + QP','REFL 166 I')
  xlabel('MICH motion [nm]',...
         'FontWeight','bold')
  axis([pos(nPR)*1e9 -pos(nPR)*1e9 -3e-4 3e-4])
  grid on

  % Error routine for output arguments
  if nargout > 3
    error('Too Many Output Arguments. Max = 3')
  end
  
  orient tall
  print -dpdf MICHsweep-40m.pdf
  
